# include <stdio.h>
# include <stdlib.h>
# include <sys/types.h>
# include <unistd.h>
# include <sys/prctl.h>
unsigned int *id_ptr=(unsigned int *) (PRDA->usr_prda.fill);
# define putID(id) ((*id_ptr)=(id))
# define getID (*id_ptr)

typedef struct parm {
	int id;
} PARM;

void test(void *parm);
main()
{
	int i;
	PARM *parm;
	pid_t pids[4];

	printf("user area address %x\n", id_ptr);
	for (i=0;i<4;i++) {
		parm=(PARM *)malloc(sizeof(PARM));
		parm->id=i;
		/** printf("PR_SADDR=%d\n", PR_SADDR); **/
		pids[i]=sproc(test, PR_SADDR, (void *)parm);
	}

	for (i=0;i<4;i++) {
		waitpid(pids[i], NULL);
	}
}

void test(void *parm)
{
	int i;
 	int id=((PARM *)parm)->id;
	unsigned int myid=(unsigned int)id;
	unsigned int id2;

	free(parm);
	putID(myid);

	for (i=0; i<10;i++) {
		usleep(rand()%1000000);
		id2=getID;
		if (myid!=id2) {
			fprintf(stderr, "proc %d found error, gid=%d\n", myid, id2);
			exit(-1);
		}
	}
	printf("%d done!\n", myid);
	return;
}
	
