# include <stdio.h>
# include <stdlib.h>

# define USE_SPROC 
/*** # define USE_PTHREAD ***/
# include "ukey.h"

ukey_t msgkey=0;

void work(void)
{
	char *buffer;
	int i;

	for (i=0;i<10;i++) {
		buffer=ukey_getval(msgkey);
		printf(buffer);

		sprintf(buffer, "From %d, phase %d\n", ukey_getid(), i);
		usleep(rand()%1000000);
	}

	printf(buffer);	

	return;
}
		
void test(void)
{
	char *buffer;
	
	buffer=(char *)malloc(100);
	ukey_setval(msgkey, (void *)buffer);
	
	sprintf(buffer, "%d starts working...\n", ukey_getid());
	work();

	return;
}


main()
{
	ukey_thr_t threads[5];
	int i;

	ukey_createkey(&msgkey);

	for (i=0; i<5;i++)
		if ((threads[i]=ukey_thrcreate(&test, (short)i))==0) {
			fprintf(stderr, "thread creation failed\n");
			/* perror(""); */
		}
	
	for (i=0; i<5; i++)
		ukey_thrwait(threads[i]);
		
}
