# include <stdio.h>
# include <stdlib.h>
# include <sys/types.h>
# include <unistd.h>
# include <sys/prctl.h>
unsigned int theid;
unsigned int *id_ptr=&theid;
# define putID(id) ((*id_ptr)=(id))
# define getID (*id_ptr)

void test(void *id);
main()
{
	int i;
	pid_t pids[8];

	for (i=0;i<8;i++) {
		pids[i]=sproc(test, PR_SADDR, i);
	}
	for (i=0;i<8;i++) {
		waitpid(pids[i], NULL);
	}
}

void test(void *id)
{
	int i;
	unsigned int myid=(unsigned int)id;
	unsigned int id2;
	putID(myid);

	for (i=0; i<100;i++) {
		usleep(rand()%1000000);
		id2=getID;
		if (myid!=id2) {
			fprintf(stderr, "proc %d found error, gid=%d\n", myid, id2);
			exit(-1);
		}
	}
	printf("%d done!\n", myid);
	return;
}
	
