# include <stdio.h>
# include <stdlib.h>
# include <ulocks.h>

/* need to define either of them */
# define USE_SPROC 
/*** # define USE_PTHREAD ***/
# include "ukey.h"

ukey_t key[101];

void setukey()
{
 	int i;
	int myid=ukey_getid();

	for (i=myid*10; i<myid*10+10;i++) {
		/* usleep(rand()%10000); */
		ukey_createkey(&(key[i]));
		ukey_setval(key[i], (void *)i);
	}
	ukey_setval(100, (void *)ukey_getid());
	return;
}

void verify()
{
	int i;
	int myid=ukey_getid();

	for (i=myid*10; i<myid*10+10;i++)
		printf("key[%d]=%d, val=%d\n", i, key[i], ukey_getval(key[i]));

	printf("Is %d==%d?\n", ukey_getid(), ukey_getval(100));
	return;
}

void test(void)
{
	setukey();
	verify();

	return;
}


main()
{
	ukey_thr_t threads[10];
	int i;

	for (i=0; i<10; i++)
		threads[i]=0;

	usconfig(CONF_INITUSERS, 64);
	for (i=0; i<10;i++)
		if ((threads[i]=ukey_thrcreate(&test, (short)i))==0) {
			fprintf(stderr, "thread creation failed\n");
			/* perror(""); */
		}
	
	for (i=0; i<10; i++)
		if (threads[i])
			ukey_thrwait(threads[i]);
		
}
